package hay.app;


import hay.component.HayAnniversary;
import hay.component.HayAnniversaryAdapter;
import hay.component.HayInsert;
import hay.database.HayDatabase;
import android.app.AlertDialog;
import android.app.ListActivity;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import android.app.Activity;
import android.app.ProgressDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.DialogInterface.OnCancelListener;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.ContactsContract;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

/**
 * This is the main Activity that displays the current chat session.
 */
public class HayExchange extends ListActivity {
	// Debugging
	private ArrayList<contact> addList;
	private ArrayList<contact> cateList;
	private ListAdapter cAdapter;
	// Message types sent from the BluetoothChatService Handler
	public static final int MESSAGE_STATE_CHANGE = 1;
	public static final int MESSAGE_READ = 2;
	public static final int MESSAGE_WRITE = 3;
	public static final int MESSAGE_DEVICE_NAME = 4;
	public static final int MESSAGE_TOAST = 5;
	public static final int MESSAGE_NEW_LIST = 6;
	public static final int MESSAGE_EXIST_LIST = 7;
	public static final int MESSAGE_UPDATE = 8;
	public static final int MESSAGE_INSERT = 9;
	public static final int Change =10;
	private static final String ATTRIBUTE_Anniversary_Contact_ID = "contact_id";
	private static final String ATTRIBUTE_Anniversary_DATE = "date";
	private static final String ATTRIBUTE_Anniversary_NAME = "name";
	private static final String ATTRIBUTE_Addition_BIRTHDAY = "birthday";
	private static final String ATTRIBUTE_Addition_TWITTERID = "twitter_id";
	private static final String ATTRIBUTE_Addition_ME2DAY = "me2day_id";
	private static final String ATTRIBUTE_Addition_Lunar = "lunar";

	Button mChangeButton;
	ImageButton sendStart;
	int pro;
	int type;
	int Max_pro;//  
	String date;
	String rcv_name ;//ּҷ̸
	int rcv_pro; //޴» īƮ
	int rcv_Max_pro; //޴» īƮ
	int rcv_count;
	BluetoothDevice device;

	int exchange_type;
	int exchange_phone;

	int exchange_email;

	int flag[] = new int [50];
	boolean up;
	int count= 0;
	ContentValues values ;
	ContentValues xday;
	String contactId = null ;
	boolean exist;
	//	ProgressBar mProg;
	ProgressDialog mProg; 
	ProgressBar waitbar;
	// Key names received from the BluetoothChatService Handler
	public static final String DEVICE_NAME = "device_name";
	public static final String TOAST = "toast";

	// Intent request codes
	private static final int REQUEST_CONNECT_DEVICE = 1;
	private static final int REQUEST_ENABLE_BT = 2;

	// Layout Views
	private TextView device_type;
	private TextView mTitle;
	private ImageButton mSendButton;

	// Name of the connected device
	private String mConnectedDeviceName = null;
	// Array adapter for the conversation thread

	// String buffer for outgoing messages
	private StringBuffer mOutStringBuffer;
	// Local Bluetooth adapter
	private BluetoothAdapter mBluetoothAdapter = null;
	// Member object for the chat services
	private BluetoothChatService mChatService = null;


	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		System.gc();

		// Set up the window layout ̾
		mProg = new ProgressDialog(HayExchange.this); 
		mProg.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
		requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
		setContentView(R.layout.exchange);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.custom_title);
		cateList = new ArrayList<contact>();
		addList = new ArrayList<contact>();
		cAdapter = new ListAdapter(cateList);
		setListAdapter(cAdapter);

		my_setup();

		mTitle = (TextView) findViewById(R.id.title_left_text);
		mTitle.setText(R.string.app_name);
		mProg.setTitle("ּҷ ȯ");
		mTitle = (TextView) findViewById(R.id.title_right_text);
		waitbar = (ProgressBar)findViewById(R.id.ProgressBar01);
		waitbar.setVisibility(View.VISIBLE);
		mProg.setCancelable(true);
		mProg.setOnCancelListener(new OnCancelListener() 
		{

			public void onCancel(DialogInterface dialog) {

				Toast.makeText(HayExchange.this, "ȯ ҵǾϴ.", Toast.LENGTH_SHORT).show();
				for( int i = 0 ; i<pro; i++){
					cateList.remove(i);
				}

				cAdapter.notifyDataSetChanged();
				cAdapter.notifyDataSetInvalidated();
			}
		});

		mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();

		Bundle data = this.getIntent().getExtras();
		type = data.getInt("type");
		if (type==0){ //ϱ
			Intent serverIntent = new Intent(this, DeviceListActivity.class);
			startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE); 
		}
		else{ //ϱ
			waitbar = (ProgressBar)findViewById(R.id.ProgressBar01);
			waitbar.setVisibility(View.VISIBLE);
			ensureDiscoverable();

		}

		// If the adapter is null, then Bluetooth is not supported
		if (mBluetoothAdapter == null) { //ġ
			Toast.makeText(this, "Bluetooth is not available", Toast.LENGTH_LONG).show();
			finish();
			return;
		}
	try{
		Log.d("qq",cateList.get(0).getName());
		for(int q = 0; q< cateList.get(0).getAnniver_name().size(); q++){
  		Log.d("qq",cateList.get(0).getAnniver_name().get(q));
  		Log.d("qq",cateList.get(0).getAnniver_date().get(q));
  		Log.d("qq",cateList.get(0).getAnn_type().get(q));
		}
		Log.d("qq",cateList.get(0).getTwit());
		Log.d("qq",cateList.get(0).getM2day());
	}
	catch(Exception e){}
		
	}

	@Override
	public void onStart() {
		super.onStart();

		// If BT is not on, request that it be enabled.
		// setupChat() will then be called during onActivityResult
		if (!mBluetoothAdapter.isEnabled()) { //  
			Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
			startActivityForResult(enableIntent, REQUEST_ENABLE_BT);
			// Otherwise, setup the chat session
		} else { //
			if (mChatService == null) setupChat();
		}
	}

	@Override
	public synchronized void onResume() {
		super.onResume();
		//	send();
		// Performing this check in onResume() covers the case in which BT was
		// not enabled during onStart(), so we were paused to enable it...
		// onResume() will be called when ACTION_REQUEST_ENABLE activity returns.
		if (mChatService != null) {
			// Only if the state is STATE_NONE, do we know that we haven't started already
			if (mChatService.getState() == BluetoothChatService.STATE_NONE) {
				// Start the Bluetooth chat services
				mChatService.start();
			}
		}
	}

	private void setupChat() {

		// Initialize the compose field with a listener for the return key
		mSendButton = (ImageButton) findViewById(R.id.button_send);
		mChangeButton = (Button) findViewById(R.exchange.device_change);
		sendStart = (ImageButton)findViewById(R.exchange.start);
		mSendButton.setImageResource(R.drawable.search_add);
		sendStart.setImageResource(R.drawable.exchange2);
		final TextView view = (TextView) findViewById(R.id.edit_text_out);
		view.setText(mBluetoothAdapter.getName());
		device_type= (TextView)findViewById(R.exchange.device_name);
		device_type.setText(" Device name : " + mBluetoothAdapter.getName());
		//۹ư
		sendStart.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Send a message using content of the edit text widget

				if (mChatService.getState() != BluetoothChatService.STATE_CONNECTED) {
					Toast.makeText(HayExchange.this, R.string.not_connected, Toast.LENGTH_SHORT).show();
				}
				else{
					pro=0;
					mProg.show();
					Max_pro = cateList.size();
					Log.d("hay",Integer.toString(cateList.size()));
					mProg.setProgress(pro);
					mProg.setMax(Max_pro);

					sendSize(Max_pro);

				}
			}
		});
		//ġ̸޼ҵ
		mChangeButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Send a message using content of the edit text widget

				String message = view.getText().toString();           
				mBluetoothAdapter.setName(message);
				view.setText(message);
				device_type.setText(" Device name : " + message);


			}
		});
		//ּҷ߰ư
		mSendButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Send a message using content of the edit text widget

				Intent i = new Intent(HayExchange.this,HayExchangeSearch.class);
				startActivityForResult(i, 1000);

			}
		});

		// Initialize the BluetoothChatService to perform bluetooth connections
		mChatService = new BluetoothChatService(this, mHandler);

		// Initialize the buffer for outgoing messages
		mOutStringBuffer = new StringBuffer("");
	}
	public void alert (){
		String []selectString = new String[] { "οּҷ", "ּҷϿ߰" };
		new AlertDialog.Builder(this).setTitle(rcv_name+"̹ϴ ּҷԴϴ").setIcon(R.drawable.icon).setItems(selectString,
				new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int which) {
				switch (which) {
				case 0:// Ӱ߰


					mHandler.sendEmptyMessage(MESSAGE_NEW_LIST);
					break;
				case 1: // ߰
					exist = false;
					mHandler.sendEmptyMessage(MESSAGE_EXIST_LIST);
					break;

				}
			}				
		}).show();
	}
	public void alert_phone (){
		String []selectString = new String[] { "ͼ", "Ӱ߰" };
		new AlertDialog.Builder(this).setTitle(rcv_name+"Ͱ մϴ").setItems(selectString,
				new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int which) {
				switch (which) {
				case 0:// ȭκ

					mHandler.sendEmptyMessage(MESSAGE_UPDATE);

					break;
				case 1: // ںκ
					mHandler.sendEmptyMessage(MESSAGE_INSERT);

					break;

				}
			}				
		}).show();
	}

	@Override
	public synchronized void onPause() {
		super.onPause();
	}

	@Override
	public void onStop() {
		super.onStop();
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
		// Stop the Bluetooth chat services
		if (mChatService != null) mChatService.stop();
	}
	/**
	 * ġ˻Ȱȭ
	 */
	private void ensureDiscoverable() {
		if (mBluetoothAdapter.getScanMode() !=
			BluetoothAdapter.SCAN_MODE_CONNECTABLE_DISCOVERABLE) {
			Intent discoverableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_DISCOVERABLE);
			discoverableIntent.putExtra(BluetoothAdapter.EXTRA_DISCOVERABLE_DURATION, 300);
			startActivity(discoverableIntent);
		}
	}

	/**
	 * Sends a message.
	 * @param message  A string of text to send.
	 * @throws UnsupportedEncodingException 
	 */
	/** Ŷ + ۸Ʈ 
	 * 
	 */
	private void sendSize(int size){
		if (mChatService.getState() != BluetoothChatService.STATE_CONNECTED) {
			Toast.makeText(this, R.string.not_connected, Toast.LENGTH_SHORT).show();
			return;
		}
		byte[] send=null;
		send =("s$"+Integer.toString(Max_pro)).getBytes();
		mChatService.write(send);
		mOutStringBuffer.setLength(0);
	}
	/**
	 * ȯϷḦ ˸
	 */
	private void sendFin(){
		if (mChatService.getState() != BluetoothChatService.STATE_CONNECTED) {
			Toast.makeText(this, R.string.not_connected, Toast.LENGTH_SHORT).show();
			return;
		}
		byte[] send=null;
		send =("f$").getBytes();
		mChatService.write(send);
		mOutStringBuffer.setLength(0);
	}
	/**
	 * Ȯξ˸޽
	 */
	private void sendAck(){
		if (mChatService.getState() != BluetoothChatService.STATE_CONNECTED) {
			Toast.makeText(this, R.string.not_connected, Toast.LENGTH_SHORT).show();
			return;
		}
		byte[] send=null;
		send =("a$").getBytes();
		mChatService.write(send);
		Log.d("hay", "send ACK");	
		mOutStringBuffer.setLength(0);
	}
	/**
	 * sendData() 
	 * ͸ ؼ ϴ  (Ʈ)
	 */
	private void sendData()  {
		// Check that we're actually connected before trying anything
		if (mChatService.getState() != BluetoothChatService.STATE_CONNECTED) {
			Toast.makeText(this, R.string.not_connected, Toast.LENGTH_SHORT).show();
			return;
		}

		byte[] send=null ;

		Log.d("hay", "packet make");
		String temp;

		temp = ("d$"+cateList.get(pro).getName()+"$");
		if(cateList.get(pro).getPhone_number().size()>0){
			for(int i = 0; i<cateList.get(pro).getPhone_number().size(); i++)
				temp+=("p$"+cateList.get(pro).getPhone_type().get(i)+"$"+cateList.get(pro).getPhone_number().get(i)+"$");
		}
		Log.d("hay", "packet make name" +temp);


		if(cateList.get(pro).getEmail().size()>0){
			for(int i = 0; i<cateList.get(pro).getEmail().size(); i++)
				temp+=("e$"+cateList.get(pro).getEmail_type().get(i)+"$"+cateList.get(pro).getEmail().get(i)+"$");
		}
		Log.d("hay", "packet make email" +temp);
		//if(cateList.get(pro).getBirth_date().compareTo("")!=0)
		//	temp+=("b$"+cateList.get(pro).getBirth_date()+"$"+cateList.get(pro).getLunar()+"$");
		Log.d("hay", "packet make birth" +temp);
		if(cateList.get(pro).getTwit().compareTo("")!=0)
			temp+=("t$"+cateList.get(pro).getTwit()+"$$");
		Log.d("hay", "packet make twit" +temp);
		if(cateList.get(pro).getM2day().compareTo("")!=0)
			temp+=("m$"+cateList.get(pro).getM2day()+"$$");
		Log.d("hay", "packet make m2day" +temp);
		if(cateList.get(pro).getAnniver_name().size()!=0){
			for(int i = 0; i<cateList.get(pro).getAnniver_name().size(); i++){
				temp+=("x$"+cateList.get(pro).getAnniver_name().get(i)+"$"+cateList.get(pro).getAnniver_date().get(i)+cateList.get(pro).getAnn_type().get(i)+cateList.get(pro).getLunar().get(i)+"$");
			}
		}
		Log.d("hay", "packet make win");
		try {
			send = temp.getBytes("UTF-8");
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		mChatService.write(send);
		Log.d("hay","write send");
		// Reset out string buffer to zero and clear the edit text field
		mOutStringBuffer.setLength(0);

		Log.d("hay","write byte");
	}

	// The action listener for the EditText widget, to listen for the return key


	// The Handler that gets information back from the BluetoothChatService
	private final Handler mHandler = new Handler() {


		String display_name=null;
		String hasPhone=null;


		Uri rawContactUri;
		long rawContactId;



		public void handleMessage(Message msg) {
			values = new ContentValues();
			switch (msg.what) {
			case MESSAGE_STATE_CHANGE:
				switch (msg.arg1) {
				case BluetoothChatService.STATE_CONNECTED:
					mTitle.setText(R.string.title_connected_to);
					mTitle.append(mConnectedDeviceName);	
					waitbar.setVisibility(View.GONE);
					break;
				case BluetoothChatService.STATE_CONNECTING:
					mTitle.setText(R.string.title_connecting);
					break;
				case BluetoothChatService.STATE_LISTEN:
				case BluetoothChatService.STATE_NONE:
					mTitle.setText(R.string.title_not_connected);
					waitbar.setVisibility(View.VISIBLE);
					break;
				}
				break;
			case MESSAGE_WRITE:
				byte[] writeBuf = (byte[]) msg.obj;
				// construct a string from the buffer
				String writeMessage = new String(writeBuf);
				break;
			case Change:
				break;
			case MESSAGE_READ:
				byte[] readBuf = (byte[]) msg.obj;
				// construct a string from the valid bytes in the buffer
				String readMessage = new String(readBuf, 0, msg.arg1);
				int proto =readMessage.indexOf("$");
				date = readMessage;
				String protocol = readMessage.substring(0,proto);
				if(protocol.compareTo("s")==0){
					Log.d("hay", "startbyte rcv");
					rcv_pro=0;

					rcv_Max_pro = Integer.parseInt(readMessage.substring(proto+1));
					Log.d("hay", "send ack start end");
					sendAck();

				}
				else if(protocol.compareTo("d")==0){

					flag[0]=proto;
					count =0 ;
					Log.d("hay", "databyte rcv");
					flag[1]=readMessage.indexOf("$",flag[0]+1);	
					rcv_name = readMessage.substring(flag[0]+1,flag[1]);

					++rcv_pro;
					exist=true;

					Cursor cursor = getContentResolver().query(ContactsContract.Contacts.CONTENT_URI,  
							null, null, null, null);  

					while (cursor.moveToNext()) {  
						display_name = cursor.getString(cursor.getColumnIndexOrThrow( ContactsContract.Contacts.DISPLAY_NAME));

						if(display_name!=null && rcv_name !=null){

							if(display_name.compareTo(rcv_name)==0){
								exist=false;
								contactId = cursor.getString(cursor.getColumnIndexOrThrow( ContactsContract.Contacts._ID));  
								hasPhone = cursor.getString(cursor.getColumnIndexOrThrow(  
										ContactsContract.Contacts.HAS_PHONE_NUMBER));  

								alert();
								break;

							}

						}

					}
					if(exist == true)
						mHandler.sendEmptyMessage(MESSAGE_NEW_LIST);

					Log.d("hay", "databyte ack");

				}
				else if(protocol.compareTo("a")==0){

					if(pro!=Max_pro){	
						Log.d("hay", "rcv ack" + pro);
						sendData();

						pro++;
						mProg.setProgress(pro);
					}
					else{
						Log.d("hay", "send fin");
						mProg.dismiss();
						sendFin();
						cateList.clear();
						cAdapter.notifyDataSetInvalidated();
						cAdapter.notifyDataSetChanged();
						Log.d("hay", "send fin end" );
						pro=0;
						Max_pro=0;
						Toast.makeText(HayExchange.this, "ȯϷ",Toast.LENGTH_SHORT).show();
					}
				}
				else if(protocol.compareTo("f")==0){
					mProg.dismiss();
					rcv_pro=0;
					rcv_Max_pro=0;
					Toast.makeText(HayExchange.this, "ȯϷ",Toast.LENGTH_SHORT).show();
				}

				break;
			case MESSAGE_DEVICE_NAME:
				// save the connected device's name
				mConnectedDeviceName = msg.getData().getString(DEVICE_NAME);
				Toast.makeText(getApplicationContext(), "Connected to "
						+ mConnectedDeviceName, Toast.LENGTH_SHORT).show();
				break;
			case MESSAGE_TOAST:
				Intent serverIntent = new Intent(HayExchange.this, DeviceListActivity.class);
				startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
				Toast.makeText(HayExchange.this, "", Toast.LENGTH_SHORT).show();
				break;
			case MESSAGE_NEW_LIST: // οƮ
				ContentValues values = new ContentValues();
				//ּҷϻ
				values.clear();
				values.put(ContactsContract.RawContacts.CONTACT_ID, 0);
				values.put(ContactsContract.RawContacts.AGGREGATION_MODE, ContactsContract.RawContacts.AGGREGATION_MODE_DISABLED);
				rawContactUri = getContentResolver().insert(ContactsContract.RawContacts.CONTENT_URI, values);
				rawContactId = ContentUris.parseId(rawContactUri);
				up= false; // Ʈ ƴ

				Log.d("hay", "NEWLIST"+Long.toString(rawContactId) +rawContactId);
				select(date,Long.toString(rawContactId));
				Log.d("hay", "NEWLISTend");
				sendAck();
				break;
			case MESSAGE_EXIST_LIST: // ϴ ּҷ̶˸
				Log.d("hay", "EXIST");
				alert_phone();
				break;
			case MESSAGE_INSERT: // ּҷϿ ߰
				Log.d("hay","Insert"+rawContactId);
				up=false;
				select(date, contactId);
				Log.d("hay","Insert true");

				sendAck();
				break;
			case MESSAGE_UPDATE: // Ʈ˸
				Log.d("hay","update");
				up=true;
				select(date, contactId);
				Log.d("hay","update true");
				sendAck();
				break;
			}


		}


	};

	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		switch (requestCode) {
		case REQUEST_CONNECT_DEVICE:
			// When DeviceListActivity returns with a device to connect
			if (resultCode == Activity.RESULT_OK) {
				// Get the device MAC address
				String address = data.getExtras()
				.getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
				// Get the BLuetoothDevice object
				BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);
				// Attempt to connect to the device
				mChatService.connect(device);
			}
			break;
		case 1000:
			if (resultCode == Activity.RESULT_OK) {
				int clear = data.getExtras().getInt("clear");
				if(clear==1){
					cateList.clear();
					my_setup();
				}
				int phone_size = data.getExtras().getInt("size");
				int temp [] = new int [phone_size ];
				temp = data.getExtras().getIntArray("contact_number");
				Log.d("hay","back Result");
				for(int i =0; i<phone_size; i++){
					Log.d("hay","for moon start");
					contact_setup(temp[i]);
					Log.d("hay","for moon in");
				}	
				cAdapter.notifyDataSetChanged();
				cAdapter.notifyDataSetInvalidated();
				Log.d("hay","for moon end");
			}
			break;
		case REQUEST_ENABLE_BT:
			// When the request to enable Bluetooth returns
			if (resultCode == Activity.RESULT_OK) {
				// Bluetooth is now enabled, so set up a chat session
				setupChat();
			} else { //  
				// User did not enable Bluetooth or an error occured
				Toast.makeText(this, "BlueTooth starting", Toast.LENGTH_SHORT).show(); 
				setupChat();

				//   finish();
			}
		}
	}
	public void select(String readMessage,String contactId){
		ContentValues xday = new ContentValues();
		HayDatabase db = new HayDatabase(this);
		db.open();
		for(int i =1; i<50;i++){
			// $ġ 
			if((flag[i+1] = readMessage.indexOf("$",flag[i]+1))!=-1){

				count++;
			}
			else
				break;
		}
		//̸Ժκ
		Log.d("hay","name gogo");
		values.clear();
		values.put(ContactsContract.Data.RAW_CONTACT_ID, Long.parseLong(contactId));
		values.put(ContactsContract.Data.MIMETYPE, ContactsContract.CommonDataKinds.StructuredName.CONTENT_ITEM_TYPE);
		values.put(ContactsContract.CommonDataKinds.StructuredName.DISPLAY_NAME,rcv_name);
		Log.d("hay","name end");
		xday.clear();
		if(up==false){ // Ʈϴ ̾ƴ϶ ̸

			getContentResolver().insert(ContactsContract.Data.CONTENT_URI, values);

		}
		for(int i = 1; i<count ; i+=3){ // Ľؼ  
			Log.d("hay","count"  + Integer.toString(i));
			if(readMessage.substring(flag[i]+1,flag[i+1]).compareTo("p")==0){

				values.clear();
				values=HayInsert.phone(contactId, Integer.parseInt(readMessage.substring(flag[i+1]+1,flag[i+2])),  readMessage.substring(flag[i+2]+1,flag[i+3]));
				if(up==true){ // Ʈ
					getContentResolver().delete(ContactsContract.Data.CONTENT_URI,ContactsContract.Data.CONTACT_ID + " = " +Long.parseLong(contactId)+ " AND "+ ContactsContract.CommonDataKinds.Phone.NUMBER  ,null);
					getContentResolver().insert(ContactsContract.Data.CONTENT_URI, values);
				}
				else // ƴ μƮ
						getContentResolver().insert(ContactsContract.Data.CONTENT_URI, values);
					values.clear();
			}
			else if(readMessage.substring(flag[i]+1,flag[i+1]).compareTo("e")==0){

				values.clear();

				values=HayInsert.email(contactId, Integer.parseInt(readMessage.substring(flag[i+1]+1,flag[i+2])),  readMessage.substring(flag[i+2]+1,flag[i+3]));
				if(up==true){
					getContentResolver().delete(ContactsContract.Data.CONTENT_URI,ContactsContract.Data.CONTACT_ID + " = " +Long.parseLong(contactId)+ " AND "+ ContactsContract.CommonDataKinds.Email.TYPE  ,null);
					getContentResolver().insert(ContactsContract.Data.CONTENT_URI, values);
				}

				else
					getContentResolver().insert(ContactsContract.Data.CONTENT_URI, values);
					values.clear();
			}
			else if(readMessage.substring(flag[i]+1,flag[i+1]).compareTo("b")==0){
				Log.d("hay", "hay birthinsert!!!s");
				values.put(ATTRIBUTE_Addition_BIRTHDAY, readMessage.substring(flag[i+1]+1,flag[i+2]));
				values.put(ATTRIBUTE_Addition_Lunar, readMessage.substring(flag[i+2]+1,flag[i+3]));
				Log.d("hay", "hay birthinsert!!!f");

			}
			else if(readMessage.substring(flag[i]+1,flag[i+1]).compareTo("t")==0){
				values.put(ATTRIBUTE_Addition_TWITTERID, readMessage.substring(flag[i+1]+1,flag[i+2]));


			}
			else if(readMessage.substring(flag[i]+1,flag[i+1]).compareTo("m")==0){
				values.put(ATTRIBUTE_Addition_ME2DAY, readMessage.substring(flag[i+1]+1,flag[i+2]));

			}
			else if(readMessage.substring(flag[i]+1,flag[i+1]).compareTo("x")==0){


				//				xday.put(ATTRIBUTE_Anniversary_Contact_ID, Integer.parseInt(contactId));
				//				xday.put(ATTRIBUTE_Anniversary_NAME, readMessage.substring(flag[i+1]+1,flag[i+2]));
				//				xday.put(ATTRIBUTE_Anniversary_DATE, readMessage.substring(flag[i+2]+1,flag[i+3]));
				//				String anny_name = xday.getAsString(ATTRIBUTE_Anniversary_NAME);
				//				String anny_date = xday.getAsString(ATTRIBUTE_Anniversary_DATE);
				/****************************************************
				if(up==true){
					db.deleteAnniversary(Integer.parseInt(contactId));
					db.insertAnnibersary(Integer.parseInt(contactId), anny_name,anny_date);
				}
				else{	Log.d("hay", "hay xdayinsert!!!s");
				db.insertAnnibersary(Integer.parseInt(contactId), anny_name,anny_date);
				Log.d("hay", "hay xdayinsert!!!f");
				}
				 ***********************/
				Log.d("hay","11111111111111111111");
				Log.d("qqq", "x-day"+readMessage.substring(flag[i+1]+1,flag[i+2])+readMessage.substring(flag[i+2]+1,flag[i+3]));
				Log.d("qqq","year"+ (readMessage.substring(flag[i+2]+1,flag[i+3])).substring(0, 4));
				Log.d("qqq","month"+ (readMessage.substring(flag[i+2]+1,flag[i+3])).substring(4,6));
				Log.d("qqq","day"+ (readMessage.substring(flag[i+2]+1,flag[i+3])).substring(6,8));
				Log.d("qqq","type"+ (readMessage.substring(flag[i+2]+1,flag[i+3])).substring(8,9));
				try{
					Log.d("qqq","name"+ (readMessage.substring(flag[i+1]+1,flag[i+2])));
				}catch (Exception e) {
					// TODO: handle exception
				}

				Log.d("mytag","lunar"+ (readMessage.substring(flag[i+2]+1,flag[i+3])).substring(9,10));
			//	values= HayInsert.special(contactId,  readMessage.substring(flag[i+1]+1,flag[i+2]));
				boolean	f;
				if ((readMessage.substring(flag[i+2]+1,flag[i+3])).substring(9,10).compareTo("1")==0)
					f=true;
					else 
						f=false;
								HayAnniversaryAdapter birthday_adapter = new HayAnniversaryAdapter(getContentResolver());
								if(Integer.parseInt((readMessage.substring(flag[i+2]+1,flag[i+3])).substring(8,9))==1){
								birthday_adapter.addAnniversary(Integer.parseInt(contactId), Integer.parseInt((readMessage.substring(flag[i+2]+1,flag[i+3])).substring(0, 4)) ,  Integer.parseInt((readMessage.substring(flag[i+2]+1,flag[i+3])).substring(4, 6)),  
										Integer.parseInt((readMessage.substring(flag[i+2]+1,flag[i+3])).substring(6, 8)),  Integer.parseInt((readMessage.substring(flag[i+2]+1,flag[i+3])).substring(8,9)), readMessage.substring(flag[i+1]+1,flag[i+2]), 
										f);
								}
								else{
									birthday_adapter.addAnniversary(Integer.parseInt(contactId), Integer.parseInt((readMessage.substring(flag[i+2]+1,flag[i+3])).substring(0, 4)) ,  Integer.parseInt((readMessage.substring(flag[i+2]+1,flag[i+3])).substring(4, 6)),  
											Integer.parseInt((readMessage.substring(flag[i+2]+1,flag[i+3])).substring(6,8)),  Integer.parseInt((readMessage.substring(flag[i+2]+1,flag[i+3])).substring(8,9)), "", 
											f);
									
								}

			}

		}

		String twitter = values.getAsString(ATTRIBUTE_Addition_TWITTERID);
		String me2day = values.getAsString(ATTRIBUTE_Addition_ME2DAY);
		Log.d("hay", "hay get lunar!!!s");

		Log.d("hay", "hay lunar out!!s");


		if(up==true){
			Log.d("hay", "hay update!!!");	
			//	Log.d("hay", "lunar=="+lunar);	
				db.deleteAddition(Integer.parseInt(contactId));
					db.insertAddtionAll(Integer.parseInt(contactId),twitter,me2day);	


		}
		else{Log.d("hay", "hay in!!!");	
			db.insertAddtionAll(Integer.parseInt(contactId),twitter,me2day);	
		Log.d("hay", "hay in out!!");	
		}

		db.close();

	}
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.option_menu, menu);
		return true;
	}
	protected void onListItemClick(ListView l, View v, final int position,
			long id) {
		super.onListItemClick(l, v, position, id);

		String[] selectString;
		selectString = new String[] { "" };
		new AlertDialog.Builder(this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectString,
				new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int what) {
				switch (what) {
				case 0:// ȭκ
					cateList.remove(position);
					cAdapter.notifyDataSetChanged();
					cAdapter.notifyDataSetInvalidated();
					break;

				}
			}
		}).setNegativeButton("", null).show();

	}
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.scan: //ġ˻
			// Launch the DeviceListActivity to see devices and do scan
			Intent serverIntent = new Intent(this, DeviceListActivity.class);
			startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
			return true;
		case R.id.discoverable: //ġ˻Ȱȭ
			// Ensure this device is discoverable by others
			ensureDiscoverable();
			return true;
		}
		return false;
	}
	private void contact_setup(int contact_id){
		ContentResolver cr = this.getContentResolver();
		Log.d("hay","contact_setup start");
		Cursor cursor2 = cr.query(
				ContactsContract.Contacts.CONTENT_URI,  
				null,
				ContactsContract.Contacts._ID + " = " + contact_id,
				null,
				null);  

		HayDatabase db = new HayDatabase(this);
		db.open();
		Log.d("hay","contact_setup db open");
		contact temp = new contact();
		if(cursor2.moveToNext()) {
			//ID,hasPhone ´.
			String hasPhone = cursor2.getString(cursor2.getColumnIndex(ContactsContract.Contacts.HAS_PHONE_NUMBER));
			String name = cursor2.getString(cursor2.getColumnIndex(ContactsContract.Contacts.DISPLAY_NAME));
			ArrayList<String> number = new ArrayList<String>();
			ArrayList<String> type = new ArrayList<String>();
			ArrayList<String> ann = new ArrayList<String>();
			ArrayList<String> emails = new ArrayList<String>();
			ArrayList<String> email_type = new ArrayList<String>();
			ArrayList<String> ann_day= new ArrayList<String>();
			ArrayList<String> lunar= new ArrayList<String>();
			ArrayList<String> ann_type= new ArrayList<String>();
			temp.setHasPhone(hasPhone.equals("1"));
			temp.setName(name);			
			Cursor email = cr.query(  
					ContactsContract.CommonDataKinds.Email.CONTENT_URI,  
					null,  
					ContactsContract.CommonDataKinds.Email.CONTACT_ID +" = "+ contact_id,  
					null,
					null);
			while(email.moveToNext()){
				int tem = email.getInt(email.getColumnIndex(ContactsContract.CommonDataKinds.Email.TYPE));
				switch(tem){
				case 1: 
					email_type.add("1");
					break;
				case 2: 
					email_type.add("2");
					break;
				case 3: 
					email_type.add("3");
					break;
				default : 
					email_type.add("4");
					break;
				}

				//ȣ 
				String stemp = email.getString(email.getColumnIndex(ContactsContract.CommonDataKinds.Email.DATA));
				emails.add(stemp);
			}
			email.close();
			if (hasPhone.equals("1")){
				//ȣ  ´.
				Log.d("hay","contact_setup hasphone equal");
				Cursor phones = cr.query(  
						ContactsContract.CommonDataKinds.Phone.CONTENT_URI,  
						null,  
						ContactsContract.CommonDataKinds.Phone.CONTACT_ID +" = "+ contact_id,  
						null,
						null);
				Log.d("hay","contact_setup while start");
				while(phones.moveToNext()) {

					//Ÿ
					int tem = phones.getInt(phones.getColumnIndex(ContactsContract.CommonDataKinds.Phone.TYPE));
					switch(tem){
					case 1: 
						type.add("1");
						break;
					case 2: 
						type.add("2");
						break;
					case 3: 
						type.add("3");
						break;
					default : 
						type.add("4");
						break;
					}

					//ȣ 
					String stemp = phones.getString(phones.getColumnIndex(ContactsContract.CommonDataKinds.Phone.NUMBER));
					number.add(stemp);
				}
				phones.close();

				HayAnniversaryAdapter birthday_adapter = new HayAnniversaryAdapter(getContentResolver());
				ArrayList<HayAnniversary> birthdays = birthday_adapter.getBirthdays(contact_id);
			
				for(int i =0; i<birthdays.size();i++){
					Log.d("mytag", "anniversary3");
					if(birthdays.get(i).getType()==1){
						ann.add(birthdays.get(i).getText());
					}
					else{
						ann.add("");
					}
					String month="";
					String day="";
					if(	birthdays.get(i).getMonth() <10)
						month = "0"+Integer.toString(birthdays.get(i).getMonth());
					else
						month = Integer.toString(birthdays.get(i).getMonth());
					Log.d("s",month);
					if(birthdays.get(i).getDay() < 10)
						day= '0'+Integer.toString(birthdays.get(i).getDay());
					else
						day= Integer.toString(birthdays.get(i).getDay());
					Log.d("s",day);
					ann_day.add(Integer.toString(birthdays.get(i).getYear())+month+day);
					ann_type.add(Integer.toString(birthdays.get(i).getType()));
					Log.d("s",Integer.toString(birthdays.get(i).getType()));
					
					if(birthdays.get(i).isLunar())
						lunar.add("1");
					else
						lunar.add("0");
				}
				Log.d("hay","contact_setup while end");
				temp.setPhone_number(number);
				temp.setPhone_type(type);
				temp.setEmail_type(email_type);
				temp.setEmail(emails);
				temp.setAnn_type(ann_type);
				temp.setAnniver_date(ann_day);
				temp.setAnniver_name(ann);
				temp.setLunar(lunar);
				///////////  Ʈͱؾ			
				String twit  = "";
				String m2day  = "";	
				Cursor anniversary_cursor = db.fetchAddtionID(contact_id);
				if(anniversary_cursor.moveToNext()){
					twit = anniversary_cursor.getString(3);
					if(twit==null) twit="";
					m2day = anniversary_cursor.getString(4);
					if(m2day==null) m2day="";

					/****************************************************
				Cursor anniversary_cursor = db.fetchAnniversaryID(contact_id);
				Log.d("hay","contact_setup anniversary");
				while(anniversary_cursor.moveToNext()){
					anniver_name = anniversary_cursor.getString(2);
					if(anniver_name==null) anniver_name="";
					anniver_date = anniversary_cursor.getString(3);
					if(anniver_date==null) anniver_date="";
					ann.add(anniver_name);
					ann_day.add(anniver_date);
				}

				Log.d("hay","contact_setup anniversary end");
				Cursor birthday_cursor = db.fetchAddtionID(contact_id);
				if(birthday_cursor.moveToNext()){
					Log.d("hay","contact_setup birth start");
					twit = birthday_cursor.getString(3);
					if(twit==null) twit="";
					m2day = birthday_cursor.getString(4);
					if(m2day==null) m2day="";
					Log.d("hay","contact_setup birth end");
				}

				temp.setAnniver_date(ann_day);
				temp.setAnniver_name(ann);
				temp.setBirth_date(birth_date);

				temp.setLunar(lunar);

				anniversary_cursor.close();
				birthday_cursor.close();
					 ****************************************************/
				}

				temp.setM2day(m2day);
				temp.setTwit(twit);
				Log.d("hay","contact_setup all add");
				cateList.add(temp);
			}
			Log.d("hay","contact_setup while end");
		}
		Log.d("hay","contact_setup return");
		db.close();

	}
	private class contact {
		int contact_id;
		String name;
		ArrayList<String> phone_number;
		ArrayList<String> email;
		ArrayList<String> phone_type;
		ArrayList<String> email_type;
		ArrayList <String>anniver_name;
		ArrayList <String>anniver_date;
		ArrayList <String> lunar;
		ArrayList <String> ann_type;
		public ArrayList<String> getAnn_type() {
			return ann_type;
		}
		public void setAnn_type(ArrayList<String> ann_type) {
			this.ann_type = ann_type;
		}
		public ArrayList<String> getLunar() {
			return lunar;
		}
		public void setLunar(ArrayList<String> lunar2) {
			lunar = lunar2;
		}
		String twit;
		String birth_date;
		String m2day;
		public ArrayList<String> getAnniver_name() {
			return anniver_name;
		}
		public void setAnniver_name(ArrayList<String> anniverName) {
			anniver_name = anniverName;
		}
		public ArrayList<String> getAnniver_date() {
			return anniver_date;
		}
		public void setAnniver_date(ArrayList<String> anniverDate) {
			anniver_date = anniverDate;
		}
		public String getTwit() {
			return twit;
		}
		public void setTwit(String twit) {
			this.twit = twit;
		}
		public String getBirth_date() {
			return birth_date;
		}
		public void setBirth_date(String birthDate) {
			birth_date = birthDate;
		}
		public String getM2day() {
			return m2day;
		}
		public void setM2day(String m2day) {
			this.m2day = m2day;
		}
		public ArrayList<String> getPhone_type() {
			return phone_type;
		}
		public void setPhone_type(ArrayList<String> phoneType) {
			phone_type = phoneType;
		}
		public ArrayList<String> getEmail_type() {
			return email_type;
		}
		public void setEmail_type(ArrayList<String> emailType) {
			email_type = emailType;
		}
		boolean hasPhone;

		public int getContact_id() {
			return contact_id;
		}
		public void setContact_id(int contactId) {
			contact_id = contactId;
		}

		public boolean isHasPhone() {
			return hasPhone;
		}
		public void setHasPhone(boolean hasPhone) {
			this.hasPhone = hasPhone;
		}
		public ArrayList<String> getPhone_number() {
			return phone_number;
		}
		public void setPhone_number(ArrayList<String> phoneNumber) {
			phone_number = phoneNumber;
		}
		public ArrayList<String> getEmail() {
			return email;
		}
		public void setEmail(ArrayList<String> email) {
			this.email = email;
		}



		public String getName() {
			return name;
		}
		public void setName(String name) {
			this.name = name;
		}


	}


	private class ListAdapter extends ArrayAdapter<contact> {

		private ArrayList<contact> items;

		public ListAdapter(ArrayList<contact> items) {
			super(HayExchange.this, 0, items);
			this.items = items;
		}

		public View getView(int position, View convertView, ViewGroup parent) {
			View v = convertView;

			if (v == null) {
				LayoutInflater vi = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = vi.inflate(R.layout.list_contact, null);
			}


			contact contact = items.get(position);

			if (contact != null) {
				TextView name = (TextView) v.findViewById(R.list_contact.name);
				TextView number = (TextView) v.findViewById(R.list_contact.phone);
				name.setText(contact.getName());
				number.setText(contact.getPhone_number().get(0));

			}
			return v;
		}
	}

	private void my_setup(){
		SharedPreferences pref = getSharedPreferences("prefa",0);
		SharedPreferences pref2 = getSharedPreferences("anni",0);
		contact temp = new contact();
		ArrayList<String> number = new ArrayList<String>();
		ArrayList<String> type = new ArrayList<String>();
		ArrayList<String> ann = new ArrayList<String>();
		ArrayList<String> emails = new ArrayList<String>();
		ArrayList<String> email_type = new ArrayList<String>();
		ArrayList<String> ann_day= new ArrayList<String>();
		ArrayList<String> lunar= new ArrayList<String>();
		ArrayList<String> ann_type= new ArrayList<String>();
		String name = pref.getString("myname", "");
		String email=pref.getString("email","");
		if(email.compareTo("")!=0){
			emails.add(email);
			email_type.add("1");
		}

		String phone =pref.getString("one","")+pref.getString("two","")+pref.getString("three","");
		number.add(phone);
		type.add("2");
		String twit="";
		String m2day="";
		String birth_date="";
		int lun = pref.getInt("lunar",0);
		birth_date = pref.getString("birth", "");
		twit = pref.getString("twitter","");
		m2day =pref.getString("me2day", "");
	
		if(birth_date.compareTo("")!=0){
		ann.add("");
		ann_day.add(birth_date);
		ann_type.add("3");
		lunar.add(Integer.toString(lun));
		}
		for(int i=0; i<pref2.getInt("anycount",0);i++){
			String anny_name=pref2.getString("anyname"+i, "");
			String anny_day=pref2.getString("anyday"+i, "");
			ann.add(anny_name);
			ann_day.add(anny_day);
			ann_type.add("1");
			lunar.add("0");
		}
		temp.setPhone_number(number);
		temp.setPhone_type(type);
		temp.setEmail_type(email_type);
		temp.setEmail(emails);
		temp.setName(name);
		temp.setAnniver_date(ann_day);
		temp.setAnniver_name(ann);
		temp.setBirth_date(birth_date);
		temp.setAnn_type(ann_type);
		temp.setM2day(m2day);
		temp.setTwit(twit);
		temp.setLunar(lunar);
		//	temp.setLunar(lunar);
		cateList.add(temp);
	}
}

