package hay.app;

import hay.component.HayAnniversary;
import hay.component.HayAnniversaryAdapter;
import hay.component.HayContact;
import hay.component.HayContactAdapter;
import hay.component.HayChange;
import hay.component.HayMe2day;
import hay.database.HayDatabase;
import java.util.ArrayList;
import twitter4j.ResponseList;
import twitter4j.Status;
import twitter4j.Twitter;
import twitter4j.TwitterFactory;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.ContentUris;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.ContactsContract;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

public class HayDetail extends Activity {

	//Ʈ 
	TextView twitter1;
	TextView twitter2;
	TextView twitter3;
	LinearLayout twit_layout;
	String[] twitterText;

	// 
	TextView me2day1;
	TextView me2day2;
	TextView me2day3;
	LinearLayout me2_layout;
	ArrayList<String> me2dayText;

	//
	private LinearLayout anni_layout;
	private int count=0;

	// ǥ
	TextView name_t; // ̸ ؽƮ
	TextView number_t; // ȭȣؽƮ
	TextView score_t;
	TextView frequency_t;

	TextView sms1; // sms1 ؽƮ
	TextView sms2;
	TextView sms3;
	TextView sms4;
	TextView contacted; // ð ؽƮ
	String number = null; // ȭȣ
	String sms_body = null; // ڳ
	LinearLayout sms_linear;

	private ImageView image;
	private ImageView picture;

	//Ѿ 
	private String 	contact_name = "";
	private ArrayList<String> contact_number;
	private int 	contact_score;
	private int 	contact_frequency;
	private long 	contact_time; 
	private int 	contact_id;
	private String 	twitter;
	private String 	me2day;

	private ArrayList<Sms> smsList;

	private HayDatabase db = new HayDatabase(this);
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.detail);

		name_t = (TextView) findViewById(R.detail.name);
		number_t = (TextView) findViewById(R.detail.number);
		score_t = (TextView) findViewById(R.detail.score);
		frequency_t = (TextView) findViewById(R.detail.contact_frequency);
		image = (ImageView)findViewById(R.detail.image);
		picture = (ImageView)findViewById(R.detail.picture);

		anni_layout = (LinearLayout)findViewById(R.detail.anni_layout);
		twitter1 = (TextView)findViewById(R.detail.tweet1);
		twitter2 = (TextView)findViewById(R.detail.tweet2);
		twitter3 = (TextView)findViewById(R.detail.tweet3);
		twit_layout = (LinearLayout)findViewById(R.detail.twit_layout);

		me2day1 = (TextView)findViewById(R.detail.me2day1);
		me2day2 = (TextView)findViewById(R.detail.me2day2);
		me2day3 = (TextView)findViewById(R.detail.me2day3);
		me2_layout = (LinearLayout)findViewById(R.detail.me2_layout);

		contacted = (TextView) findViewById(R.detail.d);
		sms1 = (TextView) findViewById(R.detail.sms1);
		sms2 = (TextView) findViewById(R.detail.sms2);
		sms3 = (TextView) findViewById(R.detail.sms3);
		sms4 = (TextView) findViewById(R.detail.sms4);
		sms_linear = (LinearLayout) findViewById(R.detail.sms_layout);

		//  callog ޹͵
		Bundle data = this.getIntent().getExtras();
		contact_id = data.getInt("contact_id");
	}

	protected void onResume() {
		super.onResume();
		
		getInfo();
		
		smsProcessing();

		//Ͽ ɼ  б
		ConnectivityManager connectivityManager = (ConnectivityManager)getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo networkInfo = connectivityManager.getActiveNetworkInfo();
		if(networkInfo !=null){
			//3G̶
			if(networkInfo.getType() == ConnectivityManager.TYPE_MOBILE ){
				// д´.
				SharedPreferences pref = getSharedPreferences("prefa",0);
				if(pref.getBoolean("save_option_3g", true)){
					//3G ϰ ߴٸ

					twitterProcessing();
					me2dayProcessing();
				}
				//ϰ ߴٸ .
				else{
					twit_layout.setVisibility(LinearLayout.GONE);
					me2_layout.setVisibility(LinearLayout.GONE);
				}

			}
			//WIFI
			else if(networkInfo.getType() == ConnectivityManager.TYPE_WIFI){
				twitterProcessing();
				me2dayProcessing();

			}
		}
	}

	protected void onPause() {
		super.onPause();
		smsList.clear();
		anni_layout.removeViews(1, count);
	}

	private void getInfo(){

		db.open();

		HayContactAdapter contactAdapter = new HayContactAdapter(getContentResolver());

		HayContact contact = contactAdapter.getContact(contact_id);	

		name_t.setText(contact.getDisplay_name());

		//getWindow().setTitle(contact.getDisplay_name()+" ");
		
		if(contact.isHasPhone()){
			String temp="";
			contact_number = new ArrayList<String>();
			for(int i =0 ; i < contact.getPhone_type().size() ; i++){
				contact_number.add(contact.getPhone_number().get(i));
				temp += ''+contact.getPhone_type().get(i)+"\n"+contact.getPhone_number().get(i)+"\n";

			}
			number_t.setText(temp);
		}

		//߰  
		Cursor cursor = db.fetchAddtionID(contact_id);

		if(cursor.moveToNext()){
			contact_score = cursor.getInt(1);
			contact_time = cursor.getLong(2);
			twitter = cursor.getString(3);
			me2day = cursor.getString(4);
			contact_frequency =  cursor.getInt(5);
		}
		else{
			contact_time = Long.MAX_VALUE;
			contact_score = 100;
			contact_frequency = 0;
			twitter = null;
			me2day = null;
			db.insertAddtion(contact_id);
		}

		score_t.setText(contact_score+"");
		frequency_t.setText(contact_frequency+"ȸ ");

		if(contact_score<20) image.setImageResource(R.drawable.state1);
		else if(contact_score<60) image.setImageResource(R.drawable.state2);
		else if(contact_score<200) image.setImageResource(R.drawable.state3);
		else if(contact_score<400) image.setImageResource(R.drawable.state4);
		else image.setImageResource(R.drawable.state5);

		Bitmap bmp = contactAdapter.loadContactPhoto(contact_id);
		
		if(bmp!=null){
			picture.setImageBitmap(bmp);
		}
		else{
			bmp= BitmapFactory.decodeResource(getResources(),R.drawable.contact_picture );
			picture.setImageBitmap(bmp);
		}
		
		//
		count=0;

		HayAnniversaryAdapter birthday_adapter = new HayAnniversaryAdapter(getContentResolver());
		ArrayList<HayAnniversary> birthdays = birthday_adapter.getBirthdays(contact_id);
		
		for(int i =0; i<birthdays.size();i++){
			HayAnniversary anniversary = birthdays.get(i);
			String type = ((anniversary.getType()==3)?"  ":"  ") + anniversary.getText();
			TextView text = new TextView(this);
			
			text.setText( "["+type+"] "+(anniversary.isLunar()?" ":" ")+ anniversary.getYear()+" "+anniversary.getMonth()+" "+anniversary.getDay()+"");
			text.setTextColor(Color.BLACK);
			
			text.setTextSize(12);
			anni_layout.addView(text);
			count++;
		}

		if(count == 0){
			TextView text = new TextView(this);
			text.setText(" ʾҽϴ.");
			text.setTextColor(Color.BLACK);
			text.setTextSize(12);
			anni_layout.addView(text);
			count++;
		}

		db.close();
	}

	private void smsProcessing(){
		smsList = new ArrayList<Sms>(); // SMSƮ

		// sms Ʈ Ҷ ġϱ ̼
		//int location = 0;

		// Ÿ޽κ
		Cursor cursor2 = getContentResolver().query(Uri.parse("content://sms/"),
				new String[]{"address","date","body"},
				null, null, null);
		while (cursor2.moveToNext()) {
			number = cursor2.getString(cursor2.getColumnIndexOrThrow("address"));
			int count = 0;
			// ش ȭȣ callog Ѿ ȭȣ ġϸ Ʈ ü
			for(int i =0 ; i< contact_number.size();i++){
				if (number.replaceAll("-", "").compareTo(contact_number.get(i).replaceAll("-", "")) == 0) {

					// ּ , ð 
					number = cursor2.getString(cursor2.getColumnIndexOrThrow("address"));
					long date = cursor2.getLong(cursor2.getColumnIndexOrThrow("date"));
					sms_body = cursor2.getString(cursor2.getColumnIndexOrThrow("body"));

					
					Sms sms_log = new Sms();
					sms_log.setName(contact_name);
					
					
					sms_log.setNumber(contact_number.get(i));
					sms_log.setBody(contact_name + "(" + HayChange.long2String(date) + ")\n" + sms_body);
					sms_log.setTime2(date);
					smsList.add(sms_log);
					if (count == 4) // ʱȭ鿡 4
						break;
				}
			}
		}


		// Ʈ ũ⸶ sms 뼳
		if (smsList.size() >= 4) {
			sms1.setText(smsList.get(0).getBody());
			sms2.setText(smsList.get(1).getBody());
			sms3.setText(smsList.get(2).getBody());
			sms4.setText(smsList.get(3).getBody());

		} else if (smsList.size() == 3) {
			sms1.setText(smsList.get(0).getBody());
			sms2.setText(smsList.get(1).getBody());
			sms3.setText(smsList.get(2).getBody());
		} else if (smsList.size() == 2) {
			sms1.setText(smsList.get(0).getBody());
			sms2.setText(smsList.get(1).getBody());
		} else if (smsList.size() == 1) {
			sms1.setText(smsList.get(0).getBody());
		}

		if(contact_time == Long.MAX_VALUE){
			contacted.setText(" ϴ.");	
		}
		else{
			contacted.setText(HayChange.long2String(contact_time));	
		}


		// sms 󼼺⸦ 
		sms_linear.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				/*
				Intent q = new Intent(HayDetail.this, HaySmsDetail.class);
				q.putExtra("contact_number",contact_number.get(0));
				//q.putExtra("contact_name", contact_name);
				startActivity(q);
				*/
				final String[] selectNumber = new String[contact_number.size()];
				for(int i=0;i<contact_number.size();i++){
					selectNumber[i] = contact_number.get(i);
				}
				if(selectNumber.length>1){
					//ȭȣ
					new AlertDialog.Builder(HayDetail.this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectNumber,
							new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog, int which) {
							Intent i2 = new Intent(HayDetail.this,HaySmsDetail.class);
							i2.putExtra("contact_number",selectNumber[which]);
							startActivity(i2);
						}
					}).setNegativeButton("", null).show();
				}else{
					//ٷ ȭ
					Intent i2 = new Intent(HayDetail.this,HaySmsDetail.class);
					i2.putExtra("contact_number",selectNumber[0]);
					startActivity(i2);
				}
			}
		});
	}

	private void twitterProcessing(){

		twitter1.setText("...");
		twitter2.setText("");
		twitter3.setText("");

		if( twitter != null && !twitter.equals("")){

			twit_layout.setVisibility(LinearLayout.VISIBLE);

			twitterText = new String[3];

			twit_layout.setOnClickListener(
					new View.OnClickListener() {
						public void onClick(View v) {
							Intent intent = new Intent(HayDetail.this, HayWebView.class);
							intent.putExtra("id", twitter);
							intent.putExtra("url","http://mobile.twitter.com/");
							startActivity(intent);
						}
					}
			);

			Thread thread;
			thread = new Thread(null, doBackgroundThreadTwitter, "twitter");
			thread.start();
		}
		else{
			twit_layout.setVisibility(LinearLayout.GONE);
		}
	}

	private void me2dayProcessing(){

		me2day1.setText("...");
		me2day2.setText("");
		me2day3.setText("");

		if( me2day != null && !me2day.equals("")){

			me2_layout.setVisibility(LinearLayout.VISIBLE);

			me2_layout.setOnClickListener(
					new View.OnClickListener() {
						public void onClick(View v) {
							Intent intent = new Intent(HayDetail.this, HayWebView.class);
							intent.putExtra("id", me2day);
							intent.putExtra("url","http://me2day.net/");
							startActivity(intent);
						}
					}
			);

			Thread thread2;
			thread2 = new Thread(null, doBackgroundThreadMe2day, "me2day");
			thread2.start();
		}
		else{
			me2_layout.setVisibility(LinearLayout.GONE);
		}	
	}

	private Runnable doBackgroundThreadTwitter = new Runnable()
	{
		public void run()
		{
			if(twitter != null){
				Twitter twitterAdapter = new TwitterFactory().getInstance();
				try {
					ResponseList<Status> statuses = twitterAdapter.getUserTimeline(twitter);
					for (int i=0;i<statuses.size();i++) {
						if(i==3) break;
						else{
							twitterText[i] = statuses.get(i).getText();
						}
					}
					mHandler.sendMessage(mHandler.obtainMessage(DOUpdateTwitter));
				} catch (Exception e) {
					mHandler.sendMessage(mHandler.obtainMessage(DOUpdateTwitterError));
				}
			}
		}
	};

	private Runnable doBackgroundThreadMe2day = new Runnable()
	{
		public void run()
		{
			if(me2day != null){
				HayMe2day me2dayAdapter = new HayMe2day();
				me2dayText = me2dayAdapter.getPosts(me2day);
				if(me2dayText!=null) mHandler.sendMessage(mHandler.obtainMessage(DOUpdateMe2day));
				else mHandler.sendMessage(mHandler.obtainMessage(DOUpdateMe2dayError));
			}
		}
	};

	private final int DOUpdateTwitter = 1;
	private final int DOUpdateTwitterError = 2;
	private final int DOUpdateMe2day = 3;
	private final int DOUpdateMe2dayError = 4;

	private Handler mHandler = new Handler() {

		public void handleMessage(Message msg) {

			switch (msg.what){
			//Ʈ ȭ
			case DOUpdateTwitter:
				if(twitterText[0]!=null) twitter1.setText("- "+twitterText[0]);
				else  twitter1.setText("");
				if(twitterText[1]!=null) twitter2.setText("- "+twitterText[1]);
				if(twitterText[2]!=null) twitter3.setText("- "+twitterText[2]);
				break;
			case DOUpdateTwitterError:
				twitter1.setText("   ߽ϴ.\nͳ  Ȥ ̵ Ȯּ.");
				break;


				// ȭ
			case DOUpdateMe2day:
				if(me2dayText.get(0)!=null) me2day1.setText("- "+me2dayText.get(0));
				else me2day1.setText("");
				if( me2dayText.size() > 1 && me2dayText.get(1)!=null) me2day2.setText("- "+me2dayText.get(1));
				if( me2dayText.size() > 2 && me2dayText.get(2)!=null) me2day3.setText("- "+me2dayText.get(2));
				break;
			case DOUpdateMe2dayError:
				me2day1.setText("   ߽ϴ.\nͳ  Ȥ ̵ Ȯּ.");
				break;
			default:
				super.handleMessage(msg);
			}
		}
	};

	private class Sms {
		String name;
		String time;
		String number;
		long time2;
		String body;
		int type;
		public int getType() {
			return type;
		}

		public void setType(int type) {
			this.type = type;
		}

		public String getName() {
			return name;
		}

		public long getTime2() {
			return time2;
		}

		public void setBody(String body) {
			this.body = body;
		}

		public void setTime2(long time2) {
			this.time2 = time2;
		}

		public void setName(String name) {
			this.name = name;
		}

		public String getNumber() {
			return number;
		}

		public void setNumber(String number) {
			this.number = number;
		}

		public String getBody() {
			return body;
		}

		public void setScore(String body) {
			this.body = body;
		}
	}

	private static final int MODIFY_ID = 1;
	private static final int DELETE_ID = 2;

	public boolean onCreateOptionsMenu(Menu menu) {

		menu.add(0, MODIFY_ID, 0, " ,߰").setIcon(R.drawable.setting);
		menu.add(0, DELETE_ID, 0, "ȭȣ ").setIcon(R.drawable.exit);

		return super.onCreateOptionsMenu(menu);
	}

	public boolean onPrepareOptionsMenu(Menu menu) {
		return super.onPrepareOptionsMenu(menu);
	}

	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case MODIFY_ID:
			Intent intent = new Intent(Intent.ACTION_EDIT);
			intent.setData( ContentUris.withAppendedId(ContactsContract.Contacts.CONTENT_URI, contact_id) ); 
			startActivity(Intent.createChooser(intent, "Select Contact"));
			return true;
		case DELETE_ID:
			new AlertDialog.Builder(this)
			.setTitle("ȭο  ˴ϴ.\n Ͻðڽϱ?")
			.setIcon(R.drawable.icon)
			.setPositiveButton("",
					new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int which) {
					/****************
					db.open();
					db.deleteAddition(contact_id);
					db.deleteAnniversary(contact_id);
					int i = getContentResolver().delete(
							ContactsContract.RawContacts.CONTENT_URI,
							ContactsContract.RawContacts.CONTACT_ID+" = "+contact_id,
							//null,
							null);
					db.close();
					Toast.makeText(HayDetail.this, "Ǿϴ.", 0).show();
					 ******************/	
					finish();
				}
			})
			.setNegativeButton("ƴϿ", null).show();
			return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}

}
