package hay.app;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.Window;
import android.webkit.WebChromeClient;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Toast;

public class HayWebView extends Activity {

	WebView webview;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		getWindow().requestFeature(Window.FEATURE_PROGRESS);
		setContentView(R.layout.webview);

		webview = (WebView)findViewById(R.webview.webview);

		//Ѱܿ ͸ 
		Bundle data = this.getIntent().getExtras();

		// Ȩ url &  ID
		String id = data.getString("id");
		String url = data.getString("url");

		webview.loadUrl(url+id);

		//εٸ ִ κ
		try{
			webview.getSettings().setJavaScriptEnabled(true);

			final Activity activity = this;
			webview.setWebChromeClient(new WebChromeClient() {
				public void onProgressChanged(WebView view, int progress) {
					activity.setProgress(progress * 100);
				} 
			});

			webview.setWebViewClient(new WebViewClient() {
				public void onReceivedError(WebView view, int errorCode, String description, String fallingUrl){
					Toast.makeText(activity, "ε"+description, Toast.LENGTH_SHORT).show();
				}
			});
		}
		catch(Exception e){
			Log.d("mylog", e.getMessage());
		}
	}

}
