package hay.widget;


import hay.app.HayAnniversaryActivity;
import hay.app.R;



import hay.component.HayAnniversary;
import hay.component.HayAnniversaryAdapter;
import hay.component.HayContact;
import hay.component.HayContactAdapter;
import hay.component.LunarCheck;
import hay.database.HayDatabase;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;

import android.app.PendingIntent;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.provider.ContactsContract;
import android.widget.RemoteViews;
import android.widget.Toast;

public class haywidget extends AppWidgetProvider
{
	
	private static ArrayList<Anniversary> cateList;
	public void onUpdate( Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds )
	{   


		final int N = appWidgetIds.length;
		for (int i=0; i<N; i++) {
			int appWidgetId = appWidgetIds[i];

			onUpdateWidget(context, appWidgetManager, appWidgetId, 0);
		}


	}
	public static void onUpdateWidget(Context context, AppWidgetManager gm,
			int i, int j) {
		RemoteViews remoteViews;
		ComponentName watchWidget;
		cateList = new ArrayList<Anniversary>();
		
		
		
		
		Calendar calendar = Calendar.getInstance();
		Long date =calendar.getTimeInMillis();;
		calendar.setTimeInMillis(date);
		String time = null;
		time = calendar.get(Calendar.YEAR) + " "
		+ (calendar.get(Calendar.MONTH) + 1) + " "
		+ calendar.get(Calendar.DATE) + " ";
		addAnniversary(context.getApplicationContext());
		Intent intent = new Intent(context,HayAnniversaryActivity.class);
		//  intent.setComponent(new ComponentName("hay.widget", "hay.app.haywidget"));
		Intent intent2 = new Intent(context,widgetReceiver.class);
		
		PendingIntent pendingIntent2 = PendingIntent.getBroadcast(context, 0, intent2, 0);
		
		//intent.addCategory(Intent.CATEGORY_BROWSABLE); 

		PendingIntent pendingIntent = PendingIntent.getActivity(context, 0, intent, 0);
		remoteViews = new RemoteViews( context.getPackageName(), R.layout.appwidgetmain );
		watchWidget = new ComponentName( context, haywidget.class );
		remoteViews.setTextViewText( R.id.Wiget_textview1, "Today - " + time +"\n"+cateList.size()+"  ֽϴ.");
		remoteViews.setOnClickPendingIntent(R.id.Wiget_LinearLayout01, pendingIntent);
		remoteViews.setOnClickPendingIntent(R.id.Button01, pendingIntent2);
		
		remoteViews.setTextViewText(R.id.Wiget_textview3,"");
		remoteViews.setTextViewText(R.id.Wiget_textview4,"");
		remoteViews.setTextViewText(R.id.Wiget_textview5,"");
		remoteViews.setTextViewText(R.id.Wiget_textview6,"");
		remoteViews.setTextViewText(R.id.Wiget_textview7,"");
		remoteViews.setTextViewText(R.id.Wiget_textview8,"");
		
		try{
			String temp;
			int remain;
			remain = cateList.get(0).getRemain();
			if(remain == 0) temp="Դϴ.";
			else if(remain > 0) temp = remain+" ϴ.";
			else temp = (-remain)+" ҽϴ.";
			remoteViews.setTextViewText(R.id.Wiget_textview3,cateList.get(0).getDisplayname());
			remoteViews.setTextViewText(R.id.Wiget_textview4,"["+cateList.get(0).getMonth()+" "+cateList.get(0).getDay()+""+"] "+temp);
			
			remain = cateList.get(1).getRemain();
			if(remain == 0) temp="Դϴ.";
			else if(remain > 0) temp = remain+" ϴ.";
			else temp = (-remain)+" ҽϴ.";
			remoteViews.setTextViewText(R.id.Wiget_textview5,cateList.get(1).getDisplayname());
			remoteViews.setTextViewText(R.id.Wiget_textview6,"["+cateList.get(1).getMonth()+" "+cateList.get(1).getDay()+""+"] "+temp);
			
			remain = cateList.get(2).getRemain();
			if(remain == 0) temp="Դϴ.";
			else if(remain > 0) temp = remain+" ϴ.";
			else temp = (-remain)+" ҽϴ.";
			remoteViews.setTextViewText(R.id.Wiget_textview7,cateList.get(2).getDisplayname());
			remoteViews.setTextViewText(R.id.Wiget_textview8,"["+cateList.get(2).getMonth()+" "+cateList.get(2).getDay()+""+"] "+temp);
		}
		catch(IndexOutOfBoundsException e){
			if(cateList.size()==0){
				remoteViews.setTextViewText(R.id.Wiget_textview3,"ֱ   ϴ");
			}
		}
			gm.updateAppWidget( watchWidget, remoteViews );
		
		//Toast.makeText(context, cateList.get(0).getDisplayname(),1).show();
	}
	
	
	private static void addAnniversary(Context context){
		HayDatabase db = new HayDatabase(context.getApplicationContext());
		db.open();

		// ¥ ó ϵ ´.
		HayAnniversaryAdapter ba = new HayAnniversaryAdapter(context.getContentResolver());
		ArrayList<HayAnniversary> birthdays = ba.getBirthdays(8,4);
		
		for( int i=0 ; i<birthdays.size() ; i++ ){
			
			//ϳ ͼ
			HayAnniversary birthday = birthdays.get(i);
			
			//contact_id ͺ
			int rawcontact_id = birthday.getRawcontact_id();
			int contact_id = -1;
			
			Cursor cursor2 = context.getContentResolver().query(ContactsContract.RawContacts.CONTENT_URI,
					null,
					ContactsContract.RawContacts._ID+"="+rawcontact_id,
					null, null);
			if(cursor2.moveToNext()){
				contact_id = cursor2.getInt(cursor2.getColumnIndex(ContactsContract.RawContacts.CONTACT_ID));
			}
			
			//̸ϰ ȭȣ ͺ
			HayContactAdapter contactadapter = new HayContactAdapter(context.getContentResolver());
			HayContact contact = contactadapter.getContact(contact_id);
			
			Anniversary anniversary = new Anniversary();
			
			//   ϰ
			anniversary.setYear(birthday.getYear());
			anniversary.setMonth(birthday.getMonth());
			anniversary.setDay(birthday.getDay());
			anniversary.setRemain(birthday.getRemain());
			anniversary.setLunar(birthday.isLunar());
			anniversary.setBirthday( (birthday.getType()==3)?true:false);
			anniversary.setContact_id(contact_id);
			anniversary.setDisplayname(contact.getDisplay_name());
			anniversary.setName("");
			anniversary.setPhonenumber(contact.getPhone_number());
			
			//Ʈ 
			cateList.add(anniversary);
		}
		db.close();
	}

//	private static int nowMinusget(int month, int day){
//		Calendar calendar = Calendar.getInstance();
//
//		int now_month = calendar.get(Calendar.MONTH)+1;
//		int now_day = calendar.get(Calendar.DAY_OF_MONTH);
//
//		calendar.set(2000, now_month, now_day);
//		long now = calendar.getTimeInMillis();
//		calendar.set(2000, month, day);
//		long get = calendar.getTimeInMillis();
//
//		int value = (int)((now-get)/1000/60/60/24);
//
//		return value;
//	}
	private static class Anniversary{
		boolean birthday;
		int year;
		int month;
		int day;
		int contact_id;
		String name;
		int remain;
		String displayname;
		ArrayList<String> phonenumber;
		boolean lunar;



		public boolean isLunar() {
			return lunar;
		}
		public void setLunar(boolean lunar) {
			this.lunar = lunar;
		}
		public String getDisplayname() {
			return displayname;
		}
		public void setDisplayname(String displayname) {
			this.displayname = displayname;
		}
		public ArrayList<String> getPhonenumber() {
			return phonenumber;
		}
		public void setPhonenumber(ArrayList<String> phonenumber) {
			this.phonenumber = phonenumber;
		}
		public int getRemain() {
			return remain;
		}
		public void setRemain(int remain) {
			this.remain = remain;
		}
		public boolean isBirthday() {
			return birthday;
		}
		public void setBirthday(boolean birthday) {
			this.birthday = birthday;
		}
		public int getYear() {
			return year;
		}
		public void setYear(int year) {
			this.year = year;
		}
		public int getMonth() {
			return month;
		}
		public void setMonth(int month) {
			this.month = month;
		}
		public int getDay() {
			return day;
		}
		public void setDay(int day) {
			this.day = day;
		}
		public String getName() {
			return name;
		}
		public void setName(String name) {
			this.name = name;
		}
		public int getContact_id() {
			return contact_id;
		}
		public void setContact_id(int contactId) {
			contact_id = contactId;
		}
	}
}